Index: trunk/examples/objects/api/cpp/number
===================================================================
--- trunk/examples/objects/api/cpp/number	(revision 1581)
+++ trunk/examples/objects/api/cpp/number	(revision 1581)
@@ -0,0 +1,475 @@
+Number
+
+constructors/destructors
+    Number()
+    Number(const char *name, const char *units, double val);
+    Number(const char *name, const char *units, double val,
+           double min, double max, const char *label,
+           const char *desc);
+    Number(const Number& o);
+    ~Number ();
+
+methods
+    const char *name() const;
+    void name(const char *val);
+
+    const char *path() const;
+    void path(const char *val);
+
+    const char *label() const;
+    void label(const char *val);
+
+    const char *desc() const;
+    void desc(const char *val);
+
+    const char *hints() const;
+    void hints(const char *val);
+
+    const char *color() const;
+    void color(const char *val);
+
+    double def() const;
+    void def(double val);
+
+    double cur() const;
+    void cur(double val);
+
+    double min() const;
+    void min(double val);
+
+    double max() const;
+    void max(double val);
+
+    const char *units() const;
+    void units(const char *u);
+
+    int defset() const;
+    int curset() const;
+
+    const void *property (const char *key) const;
+    void property (const char *key, const void *val, size_t nbytes);
+
+    const char *propstr (const char *key) const;
+    void propstr (const char *key, const char *val);
+
+    void propremove (const char *key);
+
+    Outcome& convert(const char *to);
+    double value(const char *units) const;
+    void vvalue(void *storage, size_t numHints, va_list arg) const;
+
+    Number& addPreset(const char *label, const char *desc,
+                      double val, const char *units);
+
+    Number& addPreset(const char *label, const char *desc,
+                      const char *val);
+
+    Number& delPreset(const char *label);
+
+    void configure(size_t as, ClientData c);
+    void dump(size_t as, ClientData c);
+
+    Outcome &outcome() const;
+
+    const int is() const;
+
+    void minFromStr(const char *val);
+    void maxFromStr(const char *val);
+    void defFromStr(const char *val);
+    void curFromStr(const char *val);
+
+---------------------------------------
+
+const char *name()
+    Purpose: get the id name of the object
+    Input Arguments: None
+    Return Value: the id name stored in the object.
+    Notes: if no name is set, NULL will be returned
+            the id name is used to identify this object from
+            all other objects and should be unique
+    Code Example:
+
+void name(const char *val)
+    Purpose: set the id name of the object
+    Input Arguments: 1
+        1. const char *val - new id name
+    Return Value: None
+    Notes: a copy of the memory location val will be stored
+    Code Example:
+
+const char *path()
+    Purpose: get the path of the object
+    Input Arguments: None
+    Return Value: the path stored in the object.
+    Notes: if no path is set, NULL will be returned
+            the path tells where this object sits in the
+            hierarchy of objects.
+    Code Example:
+
+void path(const char *val)
+    Purpose: set the path of the object
+    Input Arguments: 1
+        1. const char *val - new path
+    Return Value: None
+    Notes: a copy of the memory location val will be stored
+    Code Example:
+
+const char *label()
+    Purpose: get the label of the object
+    Input Arguments: None
+    Return Value: the label stored in the object.
+    Notes: if no label is set, NULL will be returned
+            the label is used by the graphical user interface.
+    Code Example:
+
+void label(const char *val)
+    Purpose: set the label of the object
+    Input Arguments: 1
+        1. const char *val - new label
+    Return Value: None
+    Notes: a copy of the memory location val will be stored
+    Code Example:
+
+const char *desc()
+    Purpose: get the description of the object
+    Input Arguments: None
+    Return Value: the description stored in the object.
+    Notes: if no description is set, NULL will be returned
+            the description is used by the graphical user
+            interface to describe what type of data is being
+            requested and how the input is used.
+    Code Example:
+
+void desc(const char *val)
+    Purpose: set the description of the object
+    Input Arguments: 1
+        1. const char *val - new description
+    Return Value: None
+    Notes: a copy of the memory location val will be stored
+    Code Example:
+
+const char *hints()
+    Purpose: get the hints of the object
+    Input Arguments: None
+    Return Value: the hints stored in the object.
+    Notes: if no hints are set, NULL will be returned
+            the hints are used by the graphical user interface
+    Code Example:
+
+void hints(const char *val)
+    Purpose: set the hints of the object
+    Input Arguments: 1
+        1. const char *val - new hints
+    Return Value: None
+    Notes: a copy of the memory location val will be stored
+    Code Example:
+
+double def()
+    Purpose: get the default value
+    Input Arguments: None
+    Return Value: the default value stored in the object.
+    Notes: use the function defset() to see if a valid
+            default value was stored in the object.
+    Code Example:
+
+void def(double val)
+    Purpose: set the default value
+    Input Arguments: 1
+        1. double val - new default value
+    Return Value: None
+    Notes: None
+    Code Example:
+
+double cur()
+    Purpose: get the current value
+    Input Arguments: None
+    Return Value: the current value stored in the object.
+    Notes: use the function curset() to see if a valid
+            default value was stored in the object.
+    Code Example:
+
+void cur(double val)
+    Purpose: set the current value
+    Input Arguments: 1
+        1. double val - new current value
+    Return Value: None
+    Notes: None
+    Code Example:
+
+double min()
+    Purpose: get the minimum accepted value of this object
+    Input Arguments: None
+    Return Value: the minimum value this object will accept.
+    Notes: use the function minset() to see if a valid
+            minimum value was stored in the object.
+    Code Example:
+
+void min(double val)
+    Purpose: set the minimum accepted value of this object
+    Input Arguments: 1
+        1. double val - new minimum accepted value
+    Return Value: None
+    Notes: None
+    Code Example:
+
+double max()
+    Purpose: get the maximum accepted value of this object
+    Input Arguments: None
+    Return Value: the maximum value this object will accept.
+    Notes: use the function maxset() to see if a valid
+            maximum value was stored in the object.
+    Code Example:
+
+void max(double val)
+    Purpose: set the maximum accepted value of this object
+    Input Arguments: 1
+        1. double val - new maximum accepted value
+    Return Value: None
+    Notes: None
+    Code Example:
+
+const char* units()
+    Purpose: get the units of this object
+    Input Arguments: None
+    Return Value: the string representing the object's units
+    Notes: None
+    Code Example:
+
+void units(const char *val)
+    Purpose: set the units of this object
+    Input Arguments: 1
+        1. const char *val - new units
+    Return Value: None
+    Notes: None
+    Code Example:
+
+int defset() const
+    Purpose: return whether the default value was set by the user
+    Input Arguments: None
+    Return Value: 1 if default was set by user, otherwise 0
+    Notes: None
+    Code Example:
+
+int curset() const
+    Purpose: return whether the current value was set by the user
+    Input Arguments: None
+    Return Value: 1 if current was set by user, otherwise 0
+    Notes: None
+    Code Example:
+
+const void *property (const char *key) const;
+    Purpose: get a generic property from the property database
+    Input Arguments: 1
+        1. const char *key - property name
+    Return Value: value of the property
+    Notes: None
+    Code Example:
+
+void property (const char *key, const void *val, size_t nbytes);
+    Purpose: set a generic property in the property database
+    Input Arguments: 3
+        1. const char *key - property name
+        2. const void *val - property value
+        3. size_t nbytes - size (in bytes) of the value
+    Return Value: None
+    Notes: A copy of the memory pointed to by val is stored
+            in the property database
+    Code Example:
+
+const char *propstr (const char *key) const;
+    Purpose: get a string property from the property database
+    Input Arguments: 1
+        1. const char *key - property name
+    Return Value: value of the property
+    Notes: None
+    Code Example:
+
+void propstr (const char *key, const char *val);
+    Purpose: set a string property in the property database
+    Input Arguments: 2
+        1. const char *key - property name
+        2. const char *val - property value
+    Return Value: None
+    Notes: A copy of the memory pointed to by val is stored
+            in the property database
+    Code Example:
+
+void propremove (const char *key);
+    Purpose: remove a property from the property database
+    Input Arguments: 1
+        1. const char *key - property name
+    Return Value: value of the property
+    Notes: None
+    Code Example:
+
+Outcome& convert(const char *to);
+    Purpose: convert the def and cur values to "to" units
+    Input Arguments: 1
+        1. const char *to - string of units to convert to
+    Return Value: Outcome object
+    Notes: the values stored in the object are changed
+    Code Example:
+
+double value(const char *to) const;
+    Purpose: return the value of the object with units of "to"
+    Input Arguments: 1
+        1. const char *to - string of units to convert to
+    Return Value: value of the object
+    Notes: cur() is used as the base value. if cur was not set
+            by the user (curset() == 0), def() is used.
+            if def was not set (defset() == 0), 0.0 is used
+            as the value.
+    Code Example:
+
+void vvalue(void *storage, size_t numHints, va_list arg) const;
+    Purpose: return the value of the object after applying a
+                varying number of hints about how the value
+                should be configured
+    Input Arguments: 3
+        1. void *storage - the return value
+        2. size_t numHints - number of hints provided
+        3. va_list arg - list of hints specified as a va_list
+    Return Value: None
+    Notes: vvalue will parse out the recognisable hints from
+                va_list arg. Values stored in the object are
+                not changed.
+    Code Example:
+
+Number& addPreset(const char *label, const char *desc,
+                  double val, const char *units);
+    Purpose: add a preset to this object
+    Input Arguments: 4
+        1. const char *label - label of the preset
+        2. const char *desc - description of the preset
+        3. double val - value of the preset
+        4. const char *units - units of the preset
+    Return Value: None
+    Notes: presets are stored in the object in the same order
+                in which they are created
+    Code Example:
+
+Number& addPreset(const char *label, const char *desc,
+                  const char *val);
+    Purpose: add a preset to this object
+    Input Arguments: 3
+        1. const char *label - label of the preset
+        2. const char *desc - description of the preset
+        3. const char *val - numeric value and units of the preset
+    Return Value: None
+    Notes: presets are stored in the object in the same order
+                in which they are created
+    Code Example:
+
+Number& delPreset(const char *label);
+    Purpose: delete the preset labeled "label" from this object
+    Input Arguments: 1
+        1. const char *label - label of the preset
+    Return Value: None
+    Notes: preset is removed from the object
+    Code Example:
+
+void configure(size_t as, ClientData c);
+    Purpose: configure the object based on the data in "c".
+                use "as" to determine the type of data in "c".
+    Input Arguments: 2
+        1. size_t as - type of data stored in "c".
+                        valid values include:
+                            RPCONFIG_XML
+                            RPCONFIG_TREE
+        2. ClientData c - data to configure the object from.
+                            if as is...     then c should be...
+                            RPCONFIG_XML    const char *xmltext
+                            RPCONFIG_TREE   RP_ParserXML *object
+    Return Value: None
+    Notes: object is configured based on values in "c"
+    Code Example:
+
+void dump(size_t as, ClientData c);
+    Purpose: dump the object values based to the object "c".
+                use "as" to determine how to dump the data.
+    Input Arguments: 2
+        1. size_t as - type of data stored in "c".
+                        valid values include:
+                            RPCONFIG_XML
+                            RPCONFIG_TREE
+        2. ClientData c - data to configure the object from.
+                            if as is...     then c should be...
+                            RPCONFIG_XML    ClientDataXml *object
+                            RPCONFIG_TREE   RP_ParserXML *object
+    Return Value: None
+    Notes: None
+    Code Example:
+
+Outcome &outcome() const;
+    Purpose: return the status of this object as an Outcome.
+    Input Arguments: 0
+    Return Value: status of the object as an Outcome
+    Notes: None
+    Code Example:
+
+const int is() const;
+    Purpose: return an integer tag describing the object.
+    Input Arguments: 0
+    Return Value: integer tag unique to all number objects
+    Notes: None
+    Code Example:
+
+void minFromStr(const char *val);
+    Purpose: populate the min() value from a string.
+    Input Arguments: 1
+        1. const char *val - value and units for the
+                                minimum value
+    Return Value: None
+    Notes: This function tries to parse the string for a value
+            and a units string. if a units string is found and
+            no units have been set for the object, these units
+            become the units for the object. if there are
+            already units for this object, any value found
+            during the split is converted to the object's
+            units before being stored in min().
+    Code Example:
+
+void maxFromStr(const char *val);
+    Purpose: populate the max() value from a string.
+    Input Arguments: 1
+        1. const char *val - value and units for the
+                                maximum value
+    Return Value: None
+    Notes: This function tries to parse the string for a value
+            and a units string. if a units string is found and
+            no units have been set for the object, these units
+            become the units for the object. if there are
+            already units for this object, any value found
+            during the split is converted to the object's
+            units before being stored in max().
+    Code Example:
+
+void defFromStr(const char *val);
+    Purpose: populate the def() value from a string.
+    Input Arguments: 1
+        1. const char *val - value and units for the
+                                default value
+    Return Value: None
+    Notes: This function tries to parse the string for a value
+            and a units string. if a units string is found and
+            no units have been set for the object, these units
+            become the units for the object. if there are
+            already units for this object, any value found
+            during the split is converted to the object's
+            units before being stored in def().
+    Code Example:
+
+void curFromStr(const char *val);
+    Purpose: populate the cur() value from a string.
+    Input Arguments: 1
+        1. const char *val - value and units for the
+                                current value
+    Return Value: None
+    Notes: This function tries to parse the string for a value
+            and a units string. if a units string is found and
+            no units have been set for the object, these units
+            become the units for the object. if there are
+            already units for this object, any value found
+            during the split is converted to the object's
+            units before being stored in cur().
+    Code Example:
Index: trunk/examples/objects/api/cpp/plot
===================================================================
--- trunk/examples/objects/api/cpp/plot	(revision 1581)
+++ trunk/examples/objects/api/cpp/plot	(revision 1581)
@@ -0,0 +1,292 @@
+Plot
+
+constructors/destructors
+    Plot()
+    Plot(Library *lib)
+    Plot(const Plot& o);
+    ~Plot ();
+
+methods
+    const char *name() const;
+    void name(const char *val);
+
+    const char *path() const;
+    void path(const char *val);
+
+    const char *label() const;
+    void label(const char *val);
+
+    const char *desc() const;
+    void desc(const char *val);
+
+    const char *hints() const;
+    void hints(const char *val);
+
+    const char *color() const;
+    void color(const char *val);
+
+    const void *property (const char *key) const;
+    void property (const char *key, const void *val, size_t nbytes);
+
+    const char *propstr (const char *key) const;
+    void propstr (const char *key, const char *val);
+
+    void propremove (const char *key);
+
+    Plot& add ( size_t nPts, double *x, double *y,
+                const char *fmt, const char *name);
+
+    Plot& add (Curve *c, const char *name);
+
+    size_t count() const;
+
+    Curve *curve (const char* name) const;
+    Curve *getNthCurve(size_t n) const;
+
+    void vvalue(void *storage, size_t numHints, va_list arg) const;
+
+    void configure(size_t as, ClientData c);
+    void dump(size_t as, ClientData c);
+
+    Outcome &outcome() const;
+
+    const int is() const;
+
+---------------------------------------
+
+const char *name()
+    Purpose: get the id name of the object
+    Input Arguments: None
+    Return Value: the id name stored in the object.
+    Notes: if no name is set, NULL will be returned
+            the id name is used to identify this object from
+            all other objects and should be unique
+    Code Example:
+
+void name(const char *val)
+    Purpose: set the id name of the object
+    Input Arguments: 1
+        1. const char *val - new id name
+    Return Value: None
+    Notes: a copy of the memory location val will be stored
+    Code Example:
+
+const char *path()
+    Purpose: get the path of the object
+    Input Arguments: None
+    Return Value: the path stored in the object.
+    Notes: if no path is set, NULL will be returned
+            the path tells where this object sits in the
+            hierarchy of objects.
+    Code Example:
+
+void path(const char *val)
+    Purpose: set the path of the object
+    Input Arguments: 1
+        1. const char *val - new path
+    Return Value: None
+    Notes: a copy of the memory location val will be stored
+    Code Example:
+
+const char *label()
+    Purpose: get the label of the object
+    Input Arguments: None
+    Return Value: the label stored in the object.
+    Notes: if no label is set, NULL will be returned
+            the label is used by the graphical user interface.
+    Code Example:
+
+void label(const char *val)
+    Purpose: set the label of the object
+    Input Arguments: 1
+        1. const char *val - new label
+    Return Value: None
+    Notes: a copy of the memory location val will be stored
+    Code Example:
+
+const char *desc()
+    Purpose: get the description of the object
+    Input Arguments: None
+    Return Value: the description stored in the object.
+    Notes: if no description is set, NULL will be returned
+            the description is used by the graphical user
+            interface to describe what type of data is being
+            requested and how the input is used.
+    Code Example:
+
+void desc(const char *val)
+    Purpose: set the description of the object
+    Input Arguments: 1
+        1. const char *val - new description
+    Return Value: None
+    Notes: a copy of the memory location val will be stored
+    Code Example:
+
+const char *hints()
+    Purpose: get the hints of the object
+    Input Arguments: None
+    Return Value: the hints stored in the object.
+    Notes: if no hints are set, NULL will be returned
+            the hints are used by the graphical user interface
+    Code Example:
+
+void hints(const char *val)
+    Purpose: set the hints of the object
+    Input Arguments: 1
+        1. const char *val - new hints
+    Return Value: None
+    Notes: a copy of the memory location val will be stored
+    Code Example:
+
+const void *property (const char *key) const;
+    Purpose: get a generic property from the property database
+    Input Arguments: 1
+        1. const char *key - property name
+    Return Value: value of the property
+    Notes: None
+    Code Example:
+
+void property (const char *key, const void *val, size_t nbytes);
+    Purpose: set a generic property in the property database
+    Input Arguments: 3
+        1. const char *key - property name
+        2. const void *val - property value
+        3. size_t nbytes - size (in bytes) of the value
+    Return Value: None
+    Notes: A copy of the memory pointed to by val is stored
+            in the property database
+    Code Example:
+
+const char *propstr (const char *key) const;
+    Purpose: get a string property from the property database
+    Input Arguments: 1
+        1. const char *key - property name
+    Return Value: value of the property
+    Notes: None
+    Code Example:
+
+void propstr (const char *key, const char *val);
+    Purpose: set a string property in the property database
+    Input Arguments: 2
+        1. const char *key - property name
+        2. const char *val - property value
+    Return Value: None
+    Notes: A copy of the memory pointed to by val is stored
+            in the property database
+    Code Example:
+
+void propremove (const char *key);
+    Purpose: remove a property from the property database
+    Input Arguments: 1
+        1. const char *key - property name
+    Return Value: value of the property
+    Notes: None
+    Code Example:
+
+Plot& add (size_t nPts, double *x, double *y,
+           const char *fmt, const char *name);
+    Purpose: add data for an xy curve to the plot
+    Input Arguments: 5
+        1. size_t nPts - number of points in the x and y arrays
+        2. double *x - pointer to array representing the x axis
+        3. double *y - pointer to array representing the y axis
+        4. const char *fmt - format of the line
+        5. const char *name - id of the newly created curve
+    Return Value: reference to a Plot object
+    Notes: format can be something like "g:o" to represent
+            green line, dotted line style, circle marker.
+            this follows matlab's formatting rules.
+    Code Example:
+
+Plot& add (Curve *c, const char *name);
+    Purpose: add a Curve object to this Plot object
+    Input Arguments: 2
+        1. Curve *c - Curve object to add
+        2. const char *name - id of the Curve object
+    Return Value: reference to a Plot object
+    Notes: Curve object should not be deleted by user?
+    Code Example:
+
+size_t count() const;
+    Purpose: retrieve the number of curves in this Plot object
+    Input Arguments: 0
+    Return Value: number of curves stored in the object
+    Notes: None
+    Code Example:
+
+Curve *curve (const char* name) const;
+    Purpose: retrieve the curve with the id matching "name"
+    Input Arguments: 1
+        1. const char *name - id to Curve to be retrieved
+    Return Value: pointer to Curve object matching "name" or NULL
+    Notes: None
+    Code Example:
+
+Curve *getNthCurve(size_t n) const;
+    Purpose: return the n'th curve stored in the object
+    Input Arguments: 1
+        1. size_t n - number of the curve to retrieve
+    Return Value: pointer to the n'th Curve object stored in
+                    the Plot object or NULL
+    Notes: None
+    Code Example:
+
+void vvalue(void *storage, size_t numHints, va_list arg) const;
+    Purpose: return the value of the object after applying a
+                varying number of hints about how the value
+                should be configured
+    Input Arguments: 3
+        1. void *storage - the return value
+        2. size_t numHints - number of hints provided
+        3. va_list arg - list of hints specified as a va_list
+    Return Value: None
+    Notes: vvalue will parse out the recognisable hints from
+                va_list arg. Values stored in the object are
+                not changed.
+    Code Example:
+
+void configure(size_t as, ClientData c);
+    Purpose: configure the object based on the data in "c".
+                use "as" to determine the type of data in "c".
+    Input Arguments: 2
+        1. size_t as - type of data stored in "c".
+                        valid values include:
+                            RPCONFIG_XML
+                            RPCONFIG_TREE
+        2. ClientData c - data to configure the object from.
+                            if as is...     then c should be...
+                            RPCONFIG_XML    const char *xmltext
+                            RPCONFIG_TREE   RP_ParserXML *object
+    Return Value: None
+    Notes: object is configured based on values in "c"
+    Code Example:
+
+void dump(size_t as, ClientData c);
+    Purpose: dump the object values based to the object "c".
+                use "as" to determine how to dump the data.
+    Input Arguments: 2
+        1. size_t as - type of data stored in "c".
+                        valid values include:
+                            RPCONFIG_XML
+                            RPCONFIG_TREE
+        2. ClientData c - data to configure the object from.
+                            if as is...     then c should be...
+                            RPCONFIG_XML    ClientDataXml *object
+                            RPCONFIG_TREE   RP_ParserXML *object
+    Return Value: None
+    Notes: None
+    Code Example:
+
+Outcome &outcome() const;
+    Purpose: return the status of this object as an Outcome.
+    Input Arguments: 0
+    Return Value: status of the object as an Outcome
+    Notes: None
+    Code Example:
+
+const int is() const;
+    Purpose: return an integer tag describing the object.
+    Input Arguments: 0
+    Return Value: integer tag unique to all plot objects
+    Notes: None
+    Code Example:
Index: trunk/examples/objects/app-fermi/fermi4.c
===================================================================
--- trunk/examples/objects/app-fermi/fermi4.c	(revision 1581)
+++ trunk/examples/objects/app-fermi/fermi4.c	(revision 1581)
@@ -0,0 +1,90 @@
+
+// ----------------------------------------------------------------------
+//  EXAMPLE: Fermi-Dirac function in Python.
+//
+//  This simple example shows how to use Rappture within a simulator
+//  written in C.
+// ======================================================================
+//  AUTHOR:  Derrick Kearney, Purdue University
+//  Copyright (c) 2005-2009  Purdue Research Foundation
+//
+//  See the file "license.terms" for information on usage and
+//  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
+// ======================================================================
+
+#include "rappture.h"
+
+#include <stdlib.h>
+#include <stdio.h>
+#include <math.h>
+#include <unistd.h>
+
+int main(int argc, char * argv[]) {
+
+    Rappture_Library *lib = NULL;
+    Rappture_Number *T = NULL;
+
+    double Ef         = 0.0;
+    double E          = 0.0;
+    double dE         = 0.0;
+    double kT         = 0.0;
+    double Emin       = 0.0;
+    double Emax       = 0.0;
+    double f          = 0.0;
+    size_t nPts       = 200;
+    double EArr[nPts];
+    double fArr[nPts];
+
+    const char *curveLabel = "Fermi-Dirac Curve"
+    const char *curveDesc = "Plot of Fermi-Dirac Calculation";
+
+    Rappture::Plot *p1 = NULL;
+
+    // create a rappture library from the file filePath
+    lib = Rappture_Library_init(argv[1]);
+
+    if (Rappture_Library_error(lib) != 0) {
+        // cannot open file or out of memory
+        fprintf(stderr,Rappture_Library_traceback(lib));
+        return(Rappture_Library_error(lib));
+    }
+
+    Rappture_connect(lib,"temperature",T);
+    Rappture_Library_value(lib,"Ef",&Ef,"units=eV");
+
+    if (Rappture_Library_error(lib) != 0) {
+        // there were errors while retrieving input data values
+        // dump the tracepack
+        fprintf(stderr,Rappture_Library_traceback(lib));
+        return(Rappture_Library_error(lib));
+    }
+
+    kT = 8.61734e-5 * Rappture_Number_value(T,"K");
+    Emin = Ef - 10*kT;
+    Emax = Ef + 10*kT;
+
+    dE = 0.005*(Emax-Emin);
+
+    E = Emin;
+    for(size_t idx = 0; idx < nPts; idx++) {
+        E = E + dE;
+        f = 1.0/(1.0 + exp((E - Ef)/kT));
+        fArr[idx] = f;
+        EArr[idx] = E;
+        Rappture_Utils_Progress((int)((E-Emin)/(Emax-Emin)*100),"Iterating");
+    }
+
+    // do it the easy way,
+    // create a plot to add to the library
+    // plot is registered with lib upon object creation
+    // p1->add(nPts,xArr,yArr,format,curveLabel,curveDesc);
+
+    p1 = Rappture_Plot_init(lib);
+    Rappture_Plot_add(p1,nPts,fArr,EArr,"",curveLabel,curveDesc);
+    Rappture_Plot_propstr(p1,"xlabel","Fermi-Dirac Factor");
+    Rappture_Plot_propstr(p1,"ylabel","Energy");
+    Rappture_Plot_propstr(p1,"yunits","eV");
+
+    Rappture_Library_result(lib);
+    return 0;
+}
Index: trunk/examples/objects/app-fermi/fermi4.cc
===================================================================
--- trunk/examples/objects/app-fermi/fermi4.cc	(revision 1569)
+++ trunk/examples/objects/app-fermi/fermi4.cc	(revision 1581)
@@ -23,28 +23,34 @@
     // create a rappture library from the file filePath
     Rappture::Library lib(argv[1]);
+    Rappture::Number *T;
 
-    Rappture::Number T;
     double Ef           = 0.0;
+    double E            = 0.0;
     double dE           = 0.0;
     double kT           = 0.0;
     double Emin         = 0.0;
     double Emax         = 0.0;
+    double f            = 0.0;
     size_t nPts         = 200;
-    double E[nPts];
-    double f[nPts];
+    double EArr[nPts];
+    double fArr[nPts];
 
     if (lib.error() != 0) {
         // cannot open file or out of memory
-        fprintf(stderr, lib.traceback());
+        Rappture::Outcome o = lib.outcome();
+        fprintf(stderr, "%s",o.context());
+        fprintf(stderr, "%s",o.remark());
         exit(lib.error());
     }
 
-    Rappture::connect(&lib,"temperature",&T);
-    lib.value("Ef", &Ef, "units=eV");
+    Rappture::connect(&lib,"temperature",T);
+    lib.value("Ef", &Ef, 1, "units=eV");
 
     if (lib.error() != 0) {
         // there were errors while retrieving input data values
         // dump the tracepack
-        fprintf(stderr, lib.traceback());
+        Rappture::Outcome o = lib.outcome();
+        fprintf(stderr, "%s",o.context());
+        fprintf(stderr, "%s",o.remark());
         exit(lib.error());
     }
@@ -71,5 +77,5 @@
     // create a plot to add to the library
     // plot is registered with lib upon object creation
-    // p1->add(nPts,xArr,yArr,format,curveLabel,curveDesc);
+    // p1.add(nPts,xArr,yArr,format,curveLabel,curveDesc);
 
     Rappture::Plot p1(lib);
